import Test.QuickCheck

squares :: [Integer] -> [Integer]
squares xs  =  [ x*x | x <- xs ]

squaresRec :: [Integer] -> [Integer]
squaresRec []      =  []
squaresRec (x:xs)  =  x*x : squaresRec xs

squaresCond :: [Integer] -> [Integer]
squaresCond ws  =
  if null ws then
    []
  else
    let
      x  = head ws
      xs = tail ws
    in
      x*x : squaresCond xs

prop_squares :: [Integer] -> Bool
prop_squares xs  =  squares xs == squaresRec xs
